function C=concatenate(varargin)
  assert( nargin>=2 )
  [N,nr,nc]=find_amatsize(varargin{:});
  A=cell(1,nargin);
  for i=1:nargin
    if isamat(varargin{i})
      assert(varargin{i}.nc == nc && varargin{i}.nr == nr)
      A{i}=varargin{i}.values;
    else
      assert( size(varargin{i},1) == nr && size(varargin{i},2) == nc)
      
      A{i}=reshape(varargin{i},[1,nr,nc]);
    end
  end
  C=amat(cat(1,A{:}));
end

function [N,nr,nc]=find_amatsize(varargin)
  for i=1:nargin
    if isamat(varargin{i})
      [N,nr,nc]=size(varargin{i});
      return
    end
  end
  error('concatenate: one of the input parameters must be an amat class')
end
